// drop handling

function filemanager_test_handler(target,files,e,directory)
{
	if(in_list(files,directory)) return(null);

	var action;
	if(filemanager_button==2) action="Drag";
	else if(e.shiftKey||e.ctrlKey) action="Copy";
	else action="Move";

	if(action=="Move"&&files[0].parent==directory) return(null);

	return(action+" to '"+get_directory_name(directory)+"'");
}

function filemanager_drop_handler(target,files,e)
{
	var dest_window=find_containing_window(target);
	focus_window(dest_window);

	if(filemanager_button==2) show_filemanager_drag_menu(files,dest_window.directory,e);
	else move_filemanager_files(files,dest_window.directory,e.shiftKey||e.ctrlKey);
}

function filemanager_dir_test_handler(target,files,e)
{
	if(in_list(files,target.file)) return(null);

	var action;

	if(filemanager_button==2) action="Drag";
	else if(e.shiftKey||e.ctrlKey) action="Copy";
	else action="Move";

	return(action+" to '"+target.file.filename+"'");
}

function filemanager_dir_drop_handler(target,files,e)
{
	focus_window(find_containing_window(target));

	if(filemanager_button==2) show_filemanager_drag_menu(files,target.file,e);
	move_filemanager_files(files,target.file,e.shiftKey||e.ctrlKey);
}

function show_filemanager_drag_menu(files,directory,e)
{
	var filestr=files.length==1?"file":"files";
	var menu=[];

	menu.push({ title: "Copy "+filestr+" here", icon: ".desktop/Applications/Filemanager/copy.png",
	select_handler: function() { move_filemanager_files(files,directory,true) } });

	if(files[0].parent!=directory) menu.push({ title: "Move "+filestr+" here",
	icon: ".desktop/Applications/Filemanager/move.png",
	select_handler: function() { move_filemanager_files(files,directory,false) } });

	menu.push({ title: "Cancel", select_handler: function() { } });

	show_menu(menu,get_mouse_x(e),get_mouse_y(e));
}

function move_filemanager_files(files,destination,copy)
{
	var command,action;

	if(copy)
	{
		command=copy_files;
		action="copied";
	}
	else
	{
		command=move_files;
		action="moved";
	}


	command(files,destination,function(success,failure,errors) {
		var dest_window=find_filemanager_window(destination);
		if(dest_window) filemanager_set_selection(dest_window,success);

		if(failure.length)
		{
			alert("The following files could not be "+action+":\n"+failure.join("\n"));
		}
	});
}
