function init_notes()
{
	var icon_el=add_dock_icon(".desktop/Applications/Notes/notes.png",
	"Notes","Click to create a new note, right-click to bring all notes to front.",0,function() {
		new_note();
		save_note_list();
	});

	icon_el.oncontextmenu=function() { pop_all_notes(); return false; }

	// open notes

	var notes=get_registry("note.list",[]);
	for(var i=0;i<notes.length;i++)
	{
		var note=get_registry("note."+notes[i]);
		if(note) new_note(notes[i],note[0],note[1],note[2],note[3],note[4],note[5]);
	}
}

function new_note(noteid,contents,x,y,w,h)
{
	if(!noteid) noteid=new Date().getTime();
	if(!contents) contents="";
	if(!w) w=250;
	if(!h) h=180;

	var window_el=open_window("",x,y,w,h,false,"note");

	window_el.noteid=noteid;

	window_el.close_handler=function(window_el) {
		delete_note(window_el);
	}

	window_el.move_handler=function(window_el) {
		save_note(window_el);
	}

	window_el.resize_handler=function(window_el) {
		resize_note(window_el);
		save_note(window_el);
	}

	window_el.collapse_handler=function(window_el,collapsed) {
		//collapse_texteditor(window_el,collapsed);
	}

	var editor_el=make_element({ tag: "textarea",
	onchange: function(e) { save_note(window_el); },
	onkeypress: function(e) { setTimeout(function() { save_note(window_el); },10) }
	});
	editor_el.value=contents;

	window_el.editor_el=editor_el;
	window_el.content.appendChild(editor_el);

	resize_note(window_el);
}

function resize_note(window_el)
{
	set_full_size(window_el.editor_el,
	get_object_w(window_el.content),get_object_h(window_el.content));
}

function save_note(window_el)
{
	set_registry("note."+window_el.noteid,[window_el.editor_el.value,
	parseInt(window_el.style.left),parseInt(window_el.style.top),
	parseInt(window_el.style.width),parseInt(window_el.style.height)]);
}

function delete_note(window_el)
{
	if(confirm("Are you sure you want to remove this note?"))
	{
		remove_registry("note."+window_el.noteid);
		close_window(window_el);
		save_note_list();
	}
}

function save_note_list()
{
	var notes=[];
	var windows=document.getElementById("allwindows").childNodes;

	for(var i=0;i<windows.length;i++)
	if(windows[i].className=="note") notes.push(windows[i].noteid);

	set_registry("note.list",notes);
}

function pop_all_notes()
{
	var windows=document.getElementById("allwindows").childNodes;

	for(var i=0;i<windows.length;i++)
	if(windows[i].className=="note") focus_window(windows[i]);
}

/*function collapse_texteditor(window_el,collapsed)
{
	var editor_el=window_el.editor_el;
	if(collapsed)
	{
		window_el.stored_scroll_left=editor_el.scrollLeft;
		window_el.stored_scroll_top=editor_el.scrollTop;
		if(editor_el.setSelectionRange)
		{
			window_el.stored_sel_start=editor_el.selectionStart;
			window_el.stored_sel_end=editor_el.selectionEnd;
		}
	}
	else
	{
		editor_el.scrollLeft=window_el.stored_scroll_left;
		editor_el.scrollTop=window_el.stored_scroll_top;
		if(editor_el.setSelectionRange)
		{
			editor_el.setSelectionRange(window_el.stored_sel_start,window_el.stored_sel_end);
		}
	}
}*/

register_application(init_notes);
