// drag-and-drop

var drop_window_list=null;

function make_drop_target(element,test_handler,drop_handler)
{
	var window_el=find_containing_window(element);
	var drop_targets=window_el.drop_targets;

	if(!in_list(drop_targets,element)) drop_targets.unshift(element);

	element.draganddrop_test_handler=test_handler;
	element.draganddrop_drop_handler=drop_handler;
	element.draganddrop_window=window_el;
}

function clean_drop_targets(window_el)
{
	var drop_targets=window_el.drop_targets;

	for(var i=0;i<drop_targets.length;i++)
	if(!drop_targets[i].parentNode) drop_targets.splice(i--,1);
}

function start_drag(e,files)
{
	if(!e) e=window.event;

	var hover_element=null;

	build_target_list();

	var label,icon;
	if(files.length==1)
	{
		label=files[0].filename;
		icon=files[0].icon_large;
	}
	else
	{
		label=files.length+" files";
		icon=find_icon(".multiple","Large");
	}

	var dragtitle_el=make_element({ tag: "div", className: "dragtitle", children: ["\xa0"] });

	var dragger_el=make_element({ tag: "div", className: "dragger", style_position: "absolute", children: [
		dragtitle_el,
		{ tag: "img", src: icon },
		{ tag: "div", className: "draglabel", children: [label] }
	]});

	document.getElementsByTagName("body")[0].appendChild(dragger_el);

	var dragger_offs_x=Math.floor(get_object_w(dragger_el)/2);
	var dragger_offs_y=Math.floor(get_object_h(dragger_el)/2);
	dragger_el.style.left=(get_mouse_x(e)-dragger_offs_x)+"px";
	dragger_el.style.top=(get_mouse_y(e)-dragger_offs_y)+"px";
	dragger_el.style.display="";

	document.onmousemove=function(e)
	{
		if(!e) e=window.event;

		var x=get_mouse_x(e);
		var y=get_mouse_y(e);

		var curr_hover=find_target(x,y);
		var action;

		if(curr_hover)
		{
			action=curr_hover.draganddrop_test_handler(curr_hover,files,e)
			if(!action) curr_hover=null;
		}

		dragtitle_el.firstChild.nodeValue=action||"\xa0";

		if(curr_hover!=hover_element)
		{
			if(curr_hover) curr_hover.setAttribute("dragtarget","true");
			if(hover_element) hover_element.setAttribute("dragtarget","");

			hover_element=curr_hover;
		}

		var dragger_offs_x=Math.floor(get_object_w(dragger_el)/2);
		var dragger_offs_y=Math.floor(get_object_h(dragger_el)/2);
		dragger_el.style.left=(x-dragger_offs_x)+"px";
		dragger_el.style.top=(y-dragger_offs_y)+"px";
	}

	document.onmouseup=function(e)
	{
		if(!e) e=window.event;

		document.onmouseup=null;
		document.onmousemove=null;

		dragging_files=null;
		dragger_el.parentNode.removeChild(dragger_el);

		if(hover_element)
		{
			hover_element.setAttribute("dragtarget","");
			hover_element.draganddrop_drop_handler(hover_element,files,e);
			hover_element=null;
		}
	}

	cancel_drag(e);
}

function build_target_list()
{
	var list=[];
	var windows=document.getElementById("allwindows").childNodes;
	var floaters=document.getElementById("allfloaters").childNodes;

	for(var i=0;i<windows.length;i++) list.push(calc_target(windows[i]));

	list.sort(function(a,b) { return b.z-a.z } );

	for(var i=0;i<floaters.length;i++) list.unshift(calc_target(floaters[i]));

	drop_window_list=list;
}

function calc_target(window_el)
{
	var x=get_object_x(window_el);
	var y=get_object_y(window_el);
	var w=get_object_w(window_el);
	var h=get_object_h(window_el);
	var z=parseInt(window_el.style.zIndex);
	var targets=window_el.drop_targets;

	for(var j=0;j<targets.length;j++)
	{
		var tx=get_object_x(targets[j]);
		var ty=get_object_y(targets[j]);
		var tw=get_object_w(targets[j]);
		var th=get_object_h(targets[j]);

		targets[j].x1=tx;
		targets[j].y1=ty;
		targets[j].x2=tx+tw-1;
		targets[j].y2=ty+th-1;
	}

	return({
		x1: x, y1: y, x2:x+w-1, y2: y+h-1, z: z,
		targets: window_el.drop_targets,
		window: window_el
	});
}

function find_target(x,y)
{
	for(var i=0;i<drop_window_list.length;i++)
	{
		if(x>=drop_window_list[i].x1&&y>=drop_window_list[i].y1
		&&x<=drop_window_list[i].x2&&y<=drop_window_list[i].y2)
		{
			var targets=drop_window_list[i].targets;

			for(var j=0;j<targets.length;j++)
			{
				if(x>=targets[j].x1&&y>=targets[j].y1
				&&x<=targets[j].x2&&y<=targets[j].y2)
				return(targets[j]);
			}
			return(null);
		}
	}
	return(null);
}
