
var current_menu=null;

function show_menu(entries,x,y)
{
	if(current_menu) close_menu();

	current_menu=open_floater("menu");
	current_menu.style.position="absolute";
	current_menu.style.left=x+"px";
	current_menu.style.top=y+"px";

	for(var i=0;i<entries.length;i++)
	{
		var entry=entries[i];
		var classname=entry.select_handler?"menuentry":"menutitle";

		var selectfunc=new function(handler) { return function(e) {
			close_menu();
			if(handler) handler();
		}}(entry.select_handler);

		var entry_el=make_element({ tag: "div", className: classname, noselect: true,
		onmouseup: selectfunc, onmousedown: function(e) { if(!e) e=window.event; e.cancelBubble=true; },
		children: [
			{ tag: "img", src: entry.icon||".desktop/Libraries/Menu/blank.png" },
			entry.title]
		});

		current_menu.appendChild(entry_el);
	}

	// what about borders?
	var w=get_full_w(current_menu);
	var h=get_full_h(current_menu);
	if(x+w>window.scrollX+window.innerWidth) current_menu.style.left=(window.scrollX+window.innerWidth-w)+"px"; // doesn't really work
	if(y+h>window.scrollY+window.innerHeight) current_menu.style.top=(window.scrollY+window.innerHeight-h)+"px";

	var skipfirst=true;
	document.onmousedown=document.onmouseup=function(e) {
		if(skipfirst) skipfirst=false;
		else close_menu();
	}

	//document.oncontextmenu=function(e) { return false; }
}

function close_menu()
{
	if(!current_menu) return;

	close_floater(current_menu);
	current_menu=null;

	document.onmouseup=document.onmousedown=/*document.oncontextmenu=*/null;
}

function add_context_handler(element,handler)
{
	element.hold_onmousedown=element.onmousedown;
	element.hold_onmouseup=element.onmouseup;
	element.hold_onmousemove=element.onmousemove;

	element.onmousedown=function(e) {
		if(!e) e=window.event;
		if(e.button!=2) start_hold_timer(element,e,handler);
	}

	element.onmouseup=function(e) {
		if(!e) e=window.event;
		stop_hold_timer(element);
		if(e.button==2) handler(get_mouse_x(e),get_mouse_y(e));
	}

	element.onmousemove=function(e) {
		if(!e) e=window.event;
		test_hold_timer(element,e);
	}
}

function remove_context_handler(element)
{
	element.onmousedown=element.hold_onmousedown;
	element.onmouseup=element.hold_onmouseup;
	element.onmousemove=element.hold_onmousemove;
}

function start_hold_timer(element,e,handler)
{
	element.click_x=element.hold_x=get_mouse_x(e);
	element.click_y=element.hold_y=get_mouse_y(e);
	element.hold_timer=setTimeout(function() {
		element.hold_timer=null;
		stop_hold_timer(element);
		handler(element.click_x,element.click_y);
	},get_registry("click_and_hold_delay",500));
}

function test_hold_timer(element,e)
{
	if(element.hold_timer)
	{
		element.click_x=get_mouse_x(e);
		element.click_y=get_mouse_y(e);
		var dx=element.click_x-element.hold_x;
		var dy=element.click_y-element.hold_y;
		var threshold=get_registry("click_and_hold_threshold",8);

		if(dx<-threshold||dy<-threshold||dx>threshold||dy>threshold)
		{
			stop_hold_timer(element);
		}
	}
}

function stop_hold_timer(element)
{
	if(element.hold_timer)
	{
		clearTimeout(element.hold_timer);
		element.hold_timer=null;
	}
}
