// miscellaneous utility functions

function in_list(list,element)
{
	for(var i=0;i<list.length;i++) if(list[i]==element) return(true);
	return(false);
}

function list_index(list,element)
{
	for(var i=0;i<list.length;i++) if(list[i]==element) return(i);
	return(null);
}

function remove_list_entry(list,element)
{
	for(var i=0;i<list.length;i++) if(list[i]==element) list.splice(i--,1);
}

function get_mouse_x(e)
{
	if(e.pageX) return(e.pageX);
	else return(e.clientX+document.documentElement.scrollLeft+document.body.scrollLeft);
}

function get_mouse_y(e)
{
	if(e.pageY) return(e.pageY);
	else return(e.clientY+document.documentElement.scrollTop+document.body.scrollTop);
}

function get_object_x(obj)
{
	var left=0;
	if(obj.offsetParent)
	{
		while(obj.offsetParent)
		{
			left+=obj.offsetLeft
			if(document.defaultView&&document.defaultView.getComputedStyle&&
			document.defaultView.getComputedStyle(obj,'').getPropertyValue("position")=="fixed") left+=window.scrollX;
			obj=obj.offsetParent;
		}
	}
	else if(obj.x) left+=obj.x;

	return(left);
}

function get_object_y(obj)
{
	var top=0;
	if(obj.offsetParent)
	{
		while(obj.offsetParent)
		{
			top+=obj.offsetTop
			if(document.defaultView&&document.defaultView.getComputedStyle&&
			document.defaultView.getComputedStyle(obj,'').getPropertyValue("position")=="fixed") top+=window.scrollY;
			obj=obj.offsetParent;
		}
	}
	else if(obj.y) top+=obj.y;

	return(top);
}

function get_object_w(obj)
{
	var borders=get_object_borders(obj);
	return(obj.offsetWidth-borders[7]-borders[8]-borders[10]-borders[11]);
}

function get_object_h(obj)
{
	var borders=get_object_borders(obj);
	return(obj.offsetHeight-borders[13]-borders[14]-borders[16]-borders[17]);
}

function get_full_w(obj)
{
	var borders=get_object_borders(obj);
	return(obj.offsetWidth+borders[6]+borders[9]);
}

function get_full_h(obj)
{
	var borders=get_object_borders(obj);
	return(obj.offsetHeight+borders[12]+borders[15]);
}

function get_object_borders(obj)
{
	if(!obj.__borders)
	{
		var borders;

		if(document.defaultView&&document.defaultView.getComputedStyle)
		{
			var cstyle=document.defaultView.getComputedStyle(obj,'');

			borders=[
				parse_auto(cstyle.getPropertyValue("margin-left")),
				parse_auto(cstyle.getPropertyValue("border-left-width")),
				parse_auto(cstyle.getPropertyValue("padding-left")),
				parse_auto(cstyle.getPropertyValue("margin-right")),
				parse_auto(cstyle.getPropertyValue("border-right-width")),
				parse_auto(cstyle.getPropertyValue("padding-right")),
				parse_auto(cstyle.getPropertyValue("margin-top")),
				parse_auto(cstyle.getPropertyValue("border-top-width")),
				parse_auto(cstyle.getPropertyValue("padding-top")),
				parse_auto(cstyle.getPropertyValue("margin-bottom")),
				parse_auto(cstyle.getPropertyValue("border-bottom-width")),
				parse_auto(cstyle.getPropertyValue("padding-bottom"))
			];
		}
		else
		{
			borders=[
				parse_auto(obj.currentStyle.marginLeft),
				parse_auto(obj.currentStyle.borderLeftWidth),
				parse_auto(obj.currentStyle.paddingLeft),
				parse_auto(obj.currentStyle.marginRight),
				parse_auto(obj.currentStyle.borderRightWidth),
				parse_auto(obj.currentStyle.paddingRight),
				parse_auto(obj.currentStyle.marginTop),
				parse_auto(obj.currentStyle.borderTopWidth),
				parse_auto(obj.currentStyle.paddingTop),
				parse_auto(obj.currentStyle.marginBottom),
				parse_auto(obj.currentStyle.borderBottomWidth),
				parse_auto(obj.currentStyle.paddingBottom)
			];
		}

		obj.__borders=[
			borders[0]+borders[1]+borders[2]+borders[3]+borders[4]+borders[5],
			borders[6]+borders[7]+borders[8]+borders[9]+borders[10]+borders[11],
			borders[0]+borders[1]+borders[2],
			borders[3]+borders[4]+borders[5],
			borders[6]+borders[7]+borders[8],
			borders[9]+borders[10]+borders[11]
		].concat(borders);
	}

	return(obj.__borders);
}

function parse_auto(val)
{
	if(val.match(/^[0-9]+/)) return(parseInt(val));
	else return(0);
}

function set_full_size(obj,w,h)
{
	var borders=get_object_borders(obj);

	obj.style.width=(w-borders[0])+"px";
	obj.style.height=(h-borders[1])+"px";
}

function get_cookie(name)
{
	with(document.cookie)
	{
		var index=indexOf(name+"=");
		if(index==-1) return '';
		index=indexOf("=",index)+1;
		var endstr=indexOf(";",index);
		if(endstr==-1) endstr=length;
		return unescape(substring(index,endstr));
	}
}

function set_cookie(name,value,days)
{
	var expires;
	if(days)
	{
		var date=new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		expires="; expires="+date.toGMTString();
	}
	else expires="";
	document.cookie=name+"="+value+expires+"; path=/";
}

function get_xmlhttp()
{
	var xmlhttp;
	try { xmlhttp=new ActiveXObject("Msxml2.XMLHTTP"); }
	catch(e1)
	{
		try { xmlhttp=new ActiveXObject("Microsoft.XMLHTTP"); }
		catch(e1) { xmlhttp=null; }
	}

	if(!xmlhttp && typeof XMLHttpRequest!='undefined') xmlhttp=new XMLHttpRequest();

	return(xmlhttp);
}

function cancel_drag(e)
{
	var obj=e.srcElement||e.currentTarget;
	obj.onselectstart=function() { window.event.returnValue=false; }
	obj.ondragstart=function() { window.event.returnValue=false; }

	e.cancelBubble=true;
	if(e.preventDefault) e.preventDefault();
	e.returnValue=false;
}

function make_element(def)
{
	var element;

	if(typeof def=="object")
	{
		if(def.getAttribute) return(def); // already an object

		element=document.createElement(def.tag)

		for(key in def)
		{
			if(key=="tag"||key=="children"); // skip tag and children
			else if(key=="id"||key=="className"||key.match(/^on/)) element[key]=def[key];
			else if(key=="noselect"&&def[key]) disable_select(element);
			else if(key.match(/^style[\._]/)) eval("element."+key.replace(/_/g,".")+"='"+def[key].replace(/[\\']/g,"\\$1")+"'");
			else element.setAttribute(key,def[key]);
		}

		if(def.children)
		for(var i=0;i<def.children.length;i++) element.appendChild(make_element(def.children[i]));
	}
	else element=document.createTextNode(def);

	return(element);
}

function make_table(rows)
{
	var table_el=document.createElement("table");
	var tbody_el=document.createElement("tbody");

	for(var i=0;i<rows.length;i++)
	{
		var cells=rows[i];
		var tr_el=document.createElement("tr");

		for(var j=0;j<cells.length;j++)
		tr_el.appendChild(make_element({ tag: "td", children: [cells[j]] }));

		tbody_el.appendChild(tr_el);
	}
	table_el.appendChild(tbody_el);

	return(table_el);
}

function disable_select(obj)
{
	if(is_ie())
	{
		obj.onselectstart=function() { window.event.returnValue=false; }
		obj.ondragstart=function() { window.event.returnValue=false; }
	}
	else
	{
		obj.style.MozUserSelect="none";
	}
}

function pluralize(val,singular,plural)
{
	if(!plural) plural=singular+"s";
	if(val==1) return("1 "+singular);
	else return(val+" "+plural);
}

function is_ie()
{
	return(document.all&&!document.opera);
}

function is_safari()
{
	return(navigator.userAgent.toLowerCase().indexOf('safari')!=-1);
}
