var registry_timeout=60000; // sync once a minute.

var registry_hash;
var registry_timer;
var registry_counter;
var registry_lastclean;

function init_registry(initial)
{
	registry_hash={};
	registry_timer=null;
	registry_counter=0;
	registry_lastclean=0;

	for(key in initial) registry_hash[key]=[initial[key],0];
}

function shutdown_registry()
{
	sync_registry(true);
}

function get_registry(key,def)
{
	return(registry_hash[key]?registry_hash[key][0]:def);
}

function set_registry(key,value)
{
	registry_hash[key]=[value,++registry_counter];
	trigger_registry_timer();
}

function remove_registry(key)
{
	registry_hash[key]=[undefined,++registry_counter];
	trigger_registry_timer();
}

function trigger_registry_timer()
{
	if(!registry_timer) registry_timer=setTimeout(sync_registry,registry_timeout);
}

function sync_registry(sync)
{
	if(registry_lastclean==registry_counter) return;

	var clean=registry_counter;
	var entries=[],deletions=[];

	for(key in registry_hash)
	{
		if(registry_hash[key][1]>registry_lastclean)
		if(registry_hash[key][0]==undefined||registry_hash[key][0]==null) deletions.push(key);
		else
		{
			var value=stringify(registry_hash[key][0]);
			var keystr="'"+key.replace(/('|\\)/g,"\\$1")+"'";

			entries.push(keystr+":"+value);
		}
	}

	registry_timer=null;

	server_request("desktop.pl",
		{ task: "syncreg", entry: entries, "delete": deletions },
		function(result) {
			var response=eval(result);

			if(!response.error)
			{
				registry_lastclean=clean;
			}
			else
			{
				alert("Internal error: Couldn't update registry - "+response.error);
			}
		},
		sync
	);
}


function stringify(arg) {
        var c, i, l, s = '', v;

        switch (typeof arg) {
        case 'object':
            if (arg) {
                if (arg.constructor == Array) {
                    for (i = 0; i < arg.length; ++i) {
                        v = stringify(arg[i]);
                        if (s) {
                            s += ',';
                        }
                        s += v;
                    }
                    return '[' + s + ']';
                } else if (typeof arg.toString != 'undefined') {
                    for (i in arg) {
                        v = arg[i];
                        if (typeof v != 'undefined' && typeof v != 'function') {
                            v = stringify(v);
                            if (s) {
                                s += ',';
                            }
                            s += stringify(i) + ':' + v;
                        }
                    }
                    return '{' + s + '}';
                }
            }
            return 'null';
        case 'number':
            return isFinite(arg) ? String(arg) : 'null';
        case 'string':
            l = arg.length;
            s = '"';
            for (i = 0; i < l; i += 1) {
                c = arg.charAt(i);
                if (c >= ' ') {
                    if (c == '\\' || c == '"') {
                        s += '\\';
                    }
                    s += c;
                } else {
                    switch (c) {
                        case '\b':
                            s += '\\b';
                            break;
                        case '\f':
                            s += '\\f';
                            break;
                        case '\n':
                            s += '\\n';
                            break;
                        case '\r':
                            s += '\\r';
                            break;
                        case '\t':
                            s += '\\t';
                            break;
                        default:
                            c = c.charCodeAt();
                            s += '\\u00' + Math.floor(c / 16).toString(16) +
                                (c % 16).toString(16);
                    }
                }
            }
            return s + '"';
        case 'boolean':
            return String(arg);
        default:
            return 'null';
        }
}
