use strict;

sub make_desktop()
{
	my @scripts=map +{ file=>$_ },find_files("js");
	my @styles=map +{ file=>$_ },find_files("css");

	print "Content-Type: ".get_xhtml_content_type("utf-8",1)."\n";
	print "\n";

	print compile_template(q{
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>Desktop on <const $ENV{SERVER_NAME}></title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<loop $scripts><script type="text/javascript" src="<var $file>"></script></loop>
<style type="text/css">
<loop $styles>@import url("<var $file>");</loop>
</style>
</head>
<body onload="do_login(<var $logindata>)" onunload="do_logout()">

<div id="desktop"></div>
<div id="allwindows"></div>
<div id="allfloaters"></div>
<div id="logo">Desktop on <const $ENV{SERVER_NAME}></div>

<iframe name="upload_frame" style="display:none"></iframe>

</body>
</html>
})->(
		scripts=>\@scripts,
		styles=>\@styles,
		logindata=>get_login_data(),
	);
}

1;
