var focused_window=null;
var start_x=32,start_y=32;
var global_z=1;

function open_window(title,x,y,w,h,noresize,classname)
{
	// create window element
	var window_el=document.createElement("div");
	window_el.className=classname||"window";
	window_el.style.position="absolute";

	// fill in default values for window properties
	window_el.drop_targets=[];

	var title_el=make_element({ tag: "div", className: "title", children: [title],
	onmousedown: function(e) { move_window_handler(e,window_el); },
	ondblclick: function(e) { toggle_window(window_el); }
	});

	var top_el=make_element({ tag:"div", className: "topbar", children: [
		{ tag: "div", className: "close",
		onclick: function(e) { if(window_el.close_handler) window_el.close_handler(window_el) } },
		title_el
	]});

	var content_el=make_element({ tag: "div", className: "content" });

	var status_el=make_element({ tag: "div", className: "status", children: ["\xa0"] });

	var bottom_el=make_element({ tag: "div", className: "bottombar", children: [status_el] });

	window_el.onmousedown=function(e) { focus_window(window_el); }

	if(!noresize)
	{
		var resize_el=make_element({ tag: "div", className: "resize",
		onmousedown: function(e) { resize_window_handler(e,window_el) } });
		bottom_el.appendChild(resize_el);
	}

	window_el.appendChild(top_el);
	window_el.appendChild(content_el);
	window_el.appendChild(bottom_el);

	window_el.content=content_el;
	window_el.title_el=title_el;
	window_el.status_el=status_el;
	window_el.bottom_el=bottom_el;
	window_el.top_el=top_el;

	// fill in default values for sizes
	if(w==null) w=450;
	if(h==null) h=350;
	if(x==null||y==null)
	{
		start_x+=32; start_y+=32;
		x=start_x; y=start_y;
		if(x+w>window.innerWidth||y+h>window.innerHeight)
		{
			x=start_x=64;
			y=start_y=64;
		}
	}

	// place window and insert it
	document.getElementById("allwindows").appendChild(window_el);

	move_window(window_el,x,y);
	resize_window(window_el,w,h);
	focus_window(window_el);

	return(window_el);
}

function close_window(window_el)
{
	if(focused_window==window_el) focused_window=null;

	window_el.parentNode.removeChild(window_el);
}

function open_floater(classname)
{
	var float_el=document.createElement("div");
	float_el.className=classname||"floater";
	float_el.style.zIndex=1000000000;

	float_el.drop_targets=[];

	document.getElementById("allfloaters").appendChild(float_el);

	return(float_el);
}

function close_floater(float_el)
{
	float_el.parentNode.removeChild(float_el);
}


function focus_window(window_el)
{
	if(focused_window) focused_window.setAttribute("state","unfocused");
	focused_window=window_el;
	focused_window.setAttribute("state","focused");

	window_el.style.zIndex=global_z++;
}

function resize_window(window_el,w,h)
{
	window_el.style.width=w+"px";
	window_el.style.height=h+"px";

	set_full_size(window_el.content,w,h);
	
	if(is_ie()) window_el.content.style.position="absolute";
	if(is_safari()) set_window_status(window_el,window_el.status_el.firstChild.nodeValue);

	if(window_el.resize_handler) window_el.resize_handler(window_el);
}

function move_window(window_el,x,y)
{
	window_el.style.left=x+"px";
	window_el.style.top=y+"px";

	if(window_el.move_handler) window_el.move_handler(window_el);
}

function toggle_window(window_el)
{
	if(is_window_collapsed(window_el)) restore_window(window_el);
	else collapse_window(window_el);
}

function collapse_window(window_el)
{
	if(window_el.collapse_handler) window_el.collapse_handler(window_el,true);

	window_el.content.style.display="none";
	window_el.bottom_el.style.display="none";
	window_el.restored_height=window_el.style.height;
	window_el.style.height=get_object_h(window_el.top_el)+"px";
}

function restore_window(window_el)
{
	window_el.content.style.display="";
	window_el.bottom_el.style.display="";
	window_el.style.height=window_el.restored_height;

	if(window_el.collapse_handler) window_el.collapse_handler(window_el,false);
}

function is_window_collapsed(window_el)
{
	return(window_el.content.style.display=="none"?true:false);
}

function set_window_title(window_el,title)
{
	window_el.title_el.firstChild.nodeValue=title;
}

function set_window_status(window_el,status)
{
	window_el.status_el.firstChild.nodeValue=status?status:"\xa0";
}

function find_containing_window(element)
{
	while(element&&element.parentNode&&
	element.parentNode.id!="allwindows"&&element.parentNode.id!="allfloaters")
	element=element.parentNode;

	if(!element||!element.parentNode) return(null);
	return(element);
}

function get_window_position(window_el)
{
	return([parseInt(window_el.style.left),parseInt(window_el.style.top)]);
}

function get_window_size(window_el)
{
	if(is_window_collapsed(window_el))
	return([parseInt(window_el.style.width),parseInt(window_el.restored_height)]);
	else
	return([parseInt(window_el.style.width),parseInt(window_el.style.height)]);
}



// window event handlers

function move_window_handler(e,window_el)
{
	if(!e) e=window.event;

	var x_offs=get_object_x(window_el)-get_mouse_x(e);
	var y_offs=get_object_y(window_el)-get_mouse_y(e);

	document.onmousemove=function(e)
	{
		if(!e) e=window.event;

		var mx=get_mouse_x(e);
		var my=get_mouse_y(e);
		if(mx<0) mx=0;
		if(my<0) my=0;
		var x=mx+x_offs;
		var y=my+y_offs;
		//if(x<0) x=0;
		//if(y<0) y=0;

		move_window(window_el,x,y);
	}

	document.onmouseup=function(e)
	{
		if(!e) e=window.event;

		document.onmouseup=null;
		document.onmousemove=null;
	}

	focus_window(window_el);

	cancel_drag(e);
	return true;
}

function resize_window_handler(e,window_el)
{
	if(!e) e=window.event;

	var w_offs=get_object_w(window_el)-get_mouse_x(e);
	var h_offs=get_object_h(window_el)-get_mouse_y(e);

	document.onmousemove=function(e)
	{
		if(!e) e=window.event;

		var w=get_mouse_x(e)+w_offs;
		var h=get_mouse_y(e)+h_offs;
		if(w<100) w=100;
		if(h<100) h=100;

		resize_window(window_el,w,h);
	}

	document.onmouseup=function(e)
	{
		if(!e) e=window.event;

		document.onmouseup=null;
		document.onmousemove=null;
	}

	focus_window(window_el);

	cancel_drag(e);
	return true;
}
