#!/usr/bin/perl

use CGI::Carp qw(fatalsToBrowser set_message);

use strict;
use CGI;



BEGIN {
	sub find_files($)
	{
		my $type=shift;
		return map { glob "$_/*.$type" if(-d $_) } (glob(".desktop/Libraries/*"),glob(".desktop/Applications/*"));
	}

	require $_ for(find_files("pl"));
}



our %noauth_handlers;
our %task_handlers;

our %config;

my $query=new CGI;
my $task=$query->param("task");

if(!$task)
{
	if(%config) { make_desktop() }
	else { make_http_forward("$ENV{SCRIPT_NAME}?task=config") }
}
else
{
	set_message(\&handle_errors);

	if($noauth_handlers{$task}) { $noauth_handlers{$task}->($query) }
	else
	{
		my $auth=$query->param("auth");
		make_error("You are not properly logged in.\nReload this page to show the login prompt.") unless(check_auth($auth));

		if($task_handlers{$task}) { $task_handlers{$task}->($query) }
		else { make_error("Internal error: Task not supported.") }
	}
}



sub return_result(%)
{
	my %result=@_;

	print "Content-Type: text/javascript\n\n";
	print "(".js_hash(%result).")";
	exit;
}

sub make_error($)
{
	my $error=shift;
	print "Content-Type: text/javascript\n\n";
	print "alert(".js_string($error)."); ({})";
	exit;
}

sub handle_errors
{
	my $error=shift;
	$error=~s/&quot;/"/g; #"
	$error=~s/&amp;/&/g;
	$error=~s/&lt;/</g;
	$error=~s/&gt;/>/g;

	print "alert(".js_string($error)."); ({})";
}

